<!--suppress XmlDuplicatedId -->
<template>
    <div class="box-modalPlus" v-if="form">
        <div class="box-top">
            <div class="plus-left">
                <svg class="plus">
                    <use xlink:href="/img/sprite.svg#plus-sign-in-circle-1"></use>
                </svg>
                <p class="text-bold">{{ tt('edit_title') }}</p>
            </div>
            <div class="plus-right">
                <svg @click="$emit('close')">
                    <use xlink:href="/img/sprite.svg#cancel-button"></use>
                </svg>
            </div>
        </div>
        <form action="" @submit.prevent="create">
            <div class="box-flex-input">
                <div :class="inputBoxClass">
                    <label for="modal_form_name"><span>*</span>{{ tt('name') }}</label>
                    <input type="text" id="modal_form_name" required v-model="form.name" />
                </div>
                <div class="box-input" v-if="!isBanner">
                    <label for="modal_form_deposit"><span>*</span>{{ tt('deposit') }}</label>
                    <input type="text" id="modal_form_deposit" v-model.number="form.deposit" required />
                </div>
                <template v-else>
                    <div class="box-input2">
                        <label for="modal_form_cost"><span>*</span>{{ tt('cost') }}</label>
                        <input type="text" id="modal_form_cost" v-model.number="form.cost" required />
                    </div>
                    <div class="box-input2">
                        <label for="modal_form_link"><span>*</span>{{ tt('link') }}</label>
                        <input type="text" id="modal_form_link" v-model="form.link" required />
                    </div>
                </template>
            </div>
            <div class="box-flex-input">
                <div class="box-input" v-if="!isBanner">
                    <label for="modal_form_cost"><span>*</span>{{ tt('cost') }}</label>
                    <input type="text" id="modal_form_cost" v-model.number="form.cost" required />
                </div>
                <div :class="inputBoxClass">
                    <label for="modal_form_posted_at"><span>*</span>{{ tt('posted_at') }}</label>
                    <flat-pickr id="modal_form_posted_at" v-model="form.posted_at" :config="flatpickr_config"/>
                </div>
                <template v-if="isBanner">
                    <div class="box-input2">
                        <label for="modal_form_ended_at"><span>*</span>{{ tt('ended_at') }}</label>
                        <flat-pickr id="modal_form_ended_at" v-model="form.ended_at" :config="flatpickr_config"/>
                    </div>
                    <div class="box-input2">
                        <label for="modal_form_user_nick"><span>*</span>{{ tt('user_nick') }}</label>
                        <input type="text" id="modal_form_user_nick" v-model="form.user_nick" required />
                    </div>
                </template>
            </div>
			<div class="box-flex-input select-input-wrapper">
            	<search-user :label="tt('user')" name="user" :login="promo.user.login" v-model="form.user_id" :required="true" ref="userField"></search-user>
				<div class="box-input" v-if="!isBanner">
					<label for="modal_form_deposit_included"><span>*</span>{{ tt('deposit_included') }}</label>
					<toggle v-model="form.deposit_included" name="modal_form_deposit_included" style="margin-top: 1em"/>
				</div>
			</div>
            <label for="modal_form_description" class="textarea">{{ tt('description') }}</label>
            <textarea id="modal_form_description" v-model="form.description"></textarea>
            <button class="save">{{ $t('ui.save') }}</button>
        </form>
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
    import laravelValidationErrorParse from "../../mixins/laravelValidationErrorParse";
    import SearchUser from "../SearchUser";

    export default {
		name: "EditModal",
        props: ['type', 'promo'],
        mixins: [laravelValidationErrorParse],
        data(){
		    return {
		        form: this.promo,
                flatpickr_config: {
                    enableTime: true,
                    time_24hr: true,
                    dateFormat: "Y-m-d H:i:S",
                }
            }
        },
		watch: {
			promo(promo){
				this.form = promo;
				console.log('promo watcher')
				setTimeout(() => {
					console.log('promo watcher timeout')
					console.log(this.$refs);
					console.log(this.$refs.userField);
					if(this.$refs && this.$refs.userField){
						this.$refs.userField.selectUser(promo.user);
					}
				}, 1000);
			}
		},
        computed: {
            ...mapGetters([
                'axios'
            ]),
		    isBanner(){
		        return this.type === 'banner';
            },
            inputBoxClass(){
		        return this.isBanner ? 'box-input2' : 'box-input';
            }
        },
        methods: {
            tt(key){
                return this.$t(`promos.pages.${this.type}.modal.${key}`);
            },
            create(){
                this.axios.post(`promos/${this.promo.id}`, this.form)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal(this.tt('edit_success'));
                            this.$emit('reload');
                            this.$emit('close');
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    })
                    .catch((error) => {
                        this.displayErrorsSwal(error);
                    });
            }
        },
		mounted() {
			console.log('promo watcher')
			setTimeout(() => {
				console.log('promo watcher timeout')
				console.log(this.$refs);
				console.log(this.$refs.userField);
				if(this.$refs && this.$refs.userField){
					this.$refs.userField.selectUser(this.promo.user);
				}
			}, 1000);
		},
		components: {
		    SearchUser
        }
	}
</script>

<style scoped>

</style>
